using System;
using System.IO;
using System.Linq;
using System.Collections.Generic;
using System.Text;

class Program
{
    static void Main(string[] args)
    {
        try
        {
          if (args.Length == 1)
	  {
            Uniq(args[0]);
	  }
        }
        catch (UnauthorizedAccessException UAEx)
        {
            Console.WriteLine(UAEx.Message);
        }
        catch (PathTooLongException PathEx)
        {
            Console.WriteLine(PathEx.Message);
        }
    }
        public static void Uniq(string filename)
        {
            HashSet<UInt64> exists = new HashSet<ulong>();
            foreach (string line in File.ReadLines(filename))
            {
                string s = line.Trim().ToLower();
                UInt32 hash = FNV32(s);
                UInt64 duphash = ((ulong)s.Length << 32) ^ hash;
    
                if (!exists.Contains(duphash))
                {
                    exists.Add(duphash);
                    Console.WriteLine(line.Trim());
                }
            }
        }

        public static UInt32 FNV32(string str)
        {
            const uint FnvPrime = unchecked(16777619);
            uint hash = unchecked(2166136261);

            for (int i = 0; i < str.Length; i++)
                unchecked
            {
                hash *= FnvPrime;
                hash ^= (uint)str[i];
            }
            return hash;
        }

}